# NumberPicker demo

* order: 0

包含 onChange、step,error 样式等。

---

```js
/** @jsx createElement */
import { createElement, Component, render } from 'rax';
import View from 'nuke-view';
import Text from 'nuke-text';
import Page from 'nuke-page';
import NumberPicker from 'nuke-number-picker';

let App = class NukeDemoIndex extends Component {
  constructor() {
    super();
  }
  changeHandle = val => {
    console.log(val);
  };
  render() {
    return (
      <Page title="Number Picker">
        <Page.Intro main="autoCorrect 超出 10 自动修正" />
        <View style={styles.npwrapper}>
          <NumberPicker
            min={1}
            max={10}
            autoCorrect={true}
            defaultValue={2}
            onChange={this.changeHandle}
            step={3}
          />
        </View>
        <Page.Intro main="disabled" />
        <View style={styles.npwrapper}>
          <NumberPicker
            disabled
            min={1}
            max={1000}
            defaultValue={2}
            onChange={this.changeHandle}
            step={3}
          />
        </View>
        <Page.Intro main="error （ 超出 10 变红）" />
        <View style={styles.npwrapper}>
          <NumberPicker
            min={1}
            max={10}
            defaultValue={2}
            onChange={this.changeHandle}
            step={1}
          />
        </View>
        <Page.Intro main="数字超长" />
        <View style={[styles.npwrapper]}>
          <NumberPicker
            min={99}
            max={10000}
            defaultValue={3443}
            onChange={this.changeHandle}
            step={50}
          />
        </View>
      </Page>
    );
  }
};
const styles = {
  npwrapper: {
    width: 400,
    // backgroundColor:'red',
    padding: 40
  }
};
render(<App />);
```
